﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WordFrequency
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        Microsoft.Win32.OpenFileDialog dialog = new Microsoft.Win32.OpenFileDialog();

        private void buttonLoad_Click(object sender, RoutedEventArgs e)
        {
            bool? result = dialog.ShowDialog();
            if (!result.HasValue || !result.Value)
            {
                return;
            }

            string text = System.IO.File.ReadAllText(dialog.FileName);

            List<Word> words = new List<Word>();

            string[] parts = text.Split(new char[] { ' ', ',', '.', '\r', '\n', ':', '"', '!', '?' });
            for (int i = 0; i < parts.Length; i++)
            {
                if (parts[i] == "")
                {
                    continue;
                }

                // aufwendig mit Schleife:
                //bool found = false;
                //for (int k = 0; k < words.Count; k++)
                //{
                //    if (parts[i] == words[k].Text)
                //    {
                //        words[k].PlusOne();
                //        found = true;
                //        break;
                //    }
                //}
                //if (!found)
                //{
                //    words.Add(new Word(parts[i]));
                //}

                // eleganter mit anonymer Funktion:
                Word w = words.Find(x => x.Text == parts[i]);
                if (w == null)
                {
                    words.Add(new Word(parts[i]));
                }
                else
                {
                    w.PlusOne();
                }
            }

            // umständlich, weil man erst die Methode s bauen muss:
            // words.Sort(s);

            // eleganter mit anonymer Funktion:
            words.Sort((x, y) => -x.Frequency.CompareTo(y.Frequency));

            if (words.Count >= 2)
            {
                labelTop.Content = words[0].Text;
                labelMiddle.Content = words[1].Text;
                labelBottom.Content = words[2].Text;
            }

            // AutoGenerateColumns="True" nicht vergessen
            dataGridWords.ItemsSource = words;

            // TODO: bisherigen Inhalt der RichTextBox löschen
            if (words.Count >= 0)
            {
                int maxFreq = words.Max(x => x.Frequency);
                for (int i = 0; i < 10; i++)
                {
                    TextPointer tp = richTextBoxWords.Document.ContentEnd;
                    TextRange tr = new TextRange(tp, tp);
                    tr.Text = words[i].Text + " ";
                    tr.ApplyPropertyValue(Inline.FontSizeProperty, words[i].Frequency / (double) maxFreq * 20.0 + 5.0);
                }
            }
        }

        int s(Word x, Word y)
        {
            return -x.Frequency.CompareTo(y.Frequency);
        }
    }
}
